#################################################################
#                                                               #
# TDK ALMA Series 0806 (2016) Case Size                         #
#                                                               #
#################################################################
TFM201610ALMAR10MTAA = {"name"          : "TFM201610ALMAR10MTAA",
                        "case_imperial" : "0806",               # Imperial case size
                        "case_metric"   : "2016",               # Metric case size
                        "l_nom"         : 100e-9,               # Nomninal inductance
                        "l_tolerance"   : 0.2,                  # Percent/100
                        "dcr_max"       : 0.014,                #
                        "dcr_typ"       : 0.008,                #
                        "isat_max"      : 8.5,                  #
                        "isat_typ"      : 10,                   #
                        "itemp_max"     : 5.9,                  #
                        "itemp_typ"     : 7.7,                  #
                        "vmax"          : 20,                   # 
                        #########################################
                        # Here below are guesses                #
                        #########################################
                        "dcr_tc"        : 3950e-6,              # Generally Cu has a Tcr of about 3950ppm/°C
                        "acrl"          : 0.6 / 2,              # AC resistance of the inductor at fsw but at no bias
                        "coreloss_k"    : 2e-9,                 # Core loss gain factor (Ω•s)
                        "coreloss_tc"   : 2025e-6,              # Core loss Tc. Increase to "spread" hot and cold core losses.
                        "thjc_ind"      : 30                    # This is made up !!!!!
                        }
TFM201610ALMAR15MTAA = {"name"          : "TFM201610ALMAR15MTAA",
                        "case_imperial" : "0806",               # Imperial case size
                        "case_metric"   : "2016",               # Metric case size
                        "l_nom"         : 150e-9,               # Nomninal inductance
                        "l_tolerance"   : 0.2,                  # Percent/100
                        "dcr_max"       : 0.016,                #
                        "dcr_typ"       : 0.010,                #
                        "isat_max"      : 7.7,                  #
                        "isat_typ"      : 8.6,                  #
                        "itemp_max"     : 5.5,                  #
                        "itemp_typ"     : 6.9,                  #
                        "vmax"          : 20,                   # 
                        #########################################
                        # Here below are guesses                #
                        #########################################
                        "dcr_tc"        : 3950e-6,              # Generally Cu has a Tcr of about 3950ppm/°C
                        "acrl"          : 0.6 / 2,              # AC resistance of the inductor at fsw but at no bias
                        "coreloss_k"    : 2e-9,                 # Core loss gain factor (Ω•s)
                        "coreloss_tc"   : 2025e-6,              # Core loss Tc. Increase to "spread" hot and cold core losses.
                        "thjc_ind"      : 30                    # This is made up !!!!!
                        }
TFM201610ALMAR24MTAA = {"name"          : "TFM201610ALMAR24MTAA",
                        "case_imperial" : "0806",               # Imperial case size
                        "case_metric"   : "2016",               # Metric case size
                        "l_nom"         : 240e-9,               # Nomninal inductance
                        "l_tolerance"   : 0.2,                  # Percent/100
                        "dcr_max"       : 0.023,                #
                        "dcr_typ"       : 0.015,                #
                        "isat_max"      : 5.9,                  #
                        "isat_typ"      : 6.5,                  #
                        "itemp_max"     : 5.0,                  #
                        "itemp_typ"     : 6.2,                  #
                        "vmax"          : 20,                   # 
                        #########################################
                        # Here below are guesses                #
                        #########################################
                        "dcr_tc"        : 3950e-6,              # Generally Cu has a Tcr of about 3950ppm/°C
                        "acrl"          : 0.6 / 2,              # AC resistance of the inductor at fsw but at no bias
                        "coreloss_k"    : 2e-9,                 # Core loss gain factor (Ω•s)
                        "coreloss_tc"   : 2025e-6,              # Core loss Tc. Increase to "spread" hot and cold core losses.
                        "thjc_ind"      : 30                    # This is made up !!!!!
                        }
TFM201610ALMAR33MTAA = {"name"          : "TFM201610ALMAR33MTAA",
                        "case_imperial" : "0806",               # Imperial case size
                        "case_metric"   : "2016",               # Metric case size
                        "l_nom"         : 330e-9,               # Nomninal inductance
                        "l_tolerance"   : 0.2,                  # Percent/100
                        "dcr_max"       : 0.031,                #
                        "dcr_typ"       : 0.024,                #
                        "isat_max"      : 5.2,                  #
                        "isat_typ"      : 5.8,                  #
                        "itemp_max"     : 4.3,                  #
                        "itemp_typ"     : 4.8,                  #
                        "vmax"          : 20,                   # 
                        #########################################
                        # Here below are guesses                #
                        #########################################
                        "dcr_tc"        : 3950e-6,              # Generally Cu has a Tcr of about 3950ppm/°C
                        "acrl"          : 0.6 / 2,              # AC resistance of the inductor at fsw but at no bias
                        "coreloss_k"    : 2e-9,                 # Core loss gain factor (Ω•s)
                        "coreloss_tc"   : 2025e-6,              # Core loss Tc. Increase to "spread" hot and cold core losses.
                        "thjc_ind"      : 30                    # This is made up !!!!!
                        }
#################################################################
#                                                               #
# TDK ALMA Series 1008 (2520) Case Size                         #
#                                                               #
#################################################################
TFM252012ALMAR10MTAA = {"name"          : "TFM252012ALMAR10MTAA",
                        "case_imperial" : "1008",               # Imperial case size
                        "case_metric"   : "2520",               # Metric case size
                        "l_nom"         : 100e-9,               # Nomninal inductance
                        "l_tolerance"   : 0.2,                  # Percent/100
                        "dcr_max"       : 0.009,                #
                        "dcr_typ"       : 0.004,                #
                        "isat_max"      : 10,                   #
                        "isat_typ"      : 12,                   #
                        "itemp_max"     : 8,                    #
                        "itemp_typ"     : 12,                   #
                        "vmax"          : 20,                   # 
                        #########################################
                        # Here below are guesses                #
                        #########################################
                        "dcr_tc"        : 3950e-6,              # Generally Cu has a Tcr of about 3950ppm/°C
                        "acrl"          : 0.6 / 2,              # AC resistance of the inductor at fsw but at no bias
                        "coreloss_k"    : 2e-9,                 # Core loss gain factor (Ω•s)
                        "coreloss_tc"   : 2025e-6,              # Core loss Tc. Increase to "spread" hot and cold core losses.
                        "thjc_ind"      : 30                    # This is made up !!!!!
                        }
TFM252012ALMAR15MTAA = {"name"          : "TFM252012ALMAR15MTAA",
                        "case_imperial" : "1008",               # Imperial case size
                        "case_metric"   : "2520",               # Metric case size
                        "l_nom"         : 150e-9,               # Nomninal inductance
                        "l_tolerance"   : 0.2,                  # Percent/100
                        "dcr_max"       : 0.011,                #
                        "dcr_typ"       : 0.006,                #
                        "isat_max"      : 9.0,                  #
                        "isat_typ"      : 10 ,                  #
                        "itemp_max"     : 7.3,                  #
                        "itemp_typ"     : 9.8,                  #
                        "vmax"          : 20,                   # 
                        #########################################
                        # Here below are guesses                #
                        #########################################
                        "dcr_tc"        : 3950e-6,              # Generally Cu has a Tcr of about 3950ppm/°C
                        "acrl"          : 0.6 / 2,              # AC resistance of the inductor at fsw but at no bias
                        "coreloss_k"    : 2e-9,                 # Core loss gain factor (Ω•s)
                        "coreloss_tc"   : 2025e-6,              # Core loss Tc. Increase to "spread" hot and cold core losses.
                        "thjc_ind"      : 30                    # This is made up !!!!!
                        }
TFM252012ALMAR22MTAA = {"name"          : "TFM252012ALMAR22MTAA",
                        "case_imperial" : "1008",               # Imperial case size
                        "case_metric"   : "2520",               # Metric case size
                        "l_nom"         : 220e-9,               # Nomninal inductance
                        "l_tolerance"   : 0.2,                  # Percent/100
                        "dcr_max"       : 0.013,                #
                        "dcr_typ"       : 0.008,                #
                        "isat_max"      : 8.0,                  #
                        "isat_typ"      : 9.0,                  #
                        "itemp_max"     : 6.7,                  #
                        "itemp_typ"     : 8.5,                  #
                        "vmax"          : 20,                   # 
                        #########################################
                        # Here below are guesses                #
                        #########################################
                        "dcr_tc"        : 3950e-6,              # Generally Cu has a Tcr of about 3950ppm/°C
                        "acrl"          : 0.6 / 2,              # AC resistance of the inductor at fsw but at no bias
                        "coreloss_k"    : 2e-9,                 # Core loss gain factor (Ω•s)
                        "coreloss_tc"   :2025e-6,              # Core loss Tc. Increase to "spread" hot and cold core losses.
                        "thjc_ind"      : 30                    # This is made up !!!!!
                        }
TFM252012ALMAR33MTAA = {"name"          : "TFM252012ALMAR33MTAA",
                        "case_imperial" : "1008",               # Imperial case size
                        "case_metric"   : "2520",               # Metric case size
                        "l_nom"         : 330e-9,               # Nomninal inductance
                        "l_tolerance"   : 0.2,                  # Percent/100
                        "dcr_max"       : 0.018,                #
                        "dcr_typ"       : 0.013,                #
                        "isat_max"      : 7.0,                  #
                        "isat_typ"      : 7.8,                  #
                        "itemp_max"     : 5.7,                  #
                        "itemp_typ"     : 6.6,                  #
                        "vmax"          : 20,                   # 
                        #########################################
                        # Here below are guesses                #
                        #########################################
                        "dcr_tc"        : 3950e-6,              # Generally Cu has a Tcr of about 3950ppm/°C
                        "acrl"          : 0.6 / 2,              # AC resistance of the inductor at fsw but at no bias
                        "coreloss_k"    : 2e-9,                 # Core loss gain factor (Ω•s)
                        "coreloss_tc"   : 2025e-6,              # Core loss Tc. Increase to "spread" hot and cold core losses.
                        "thjc_ind"      : 30                    # This is made up !!!!!
                        }
#################################################################
#                                                               #
# TDK ALMA Series 1210 (3225) Case Size                         #
#                                                               #
#################################################################
TFM322512ALMAR10MTAA = {"name"          : "TFM322512ALMAR10MTAA",
                        "case_imperial" : "1210",               # Imperial case size
                        "case_metric"   : "3225",               # Metric case size
                        "l_nom"         : 100e-9,               # Nomninal inductance
                        "l_tolerance"   : 0.2,                  # Percent/100
                        "dcr_max"       : 0.008,                #
                        "dcr_typ"       : 0.003,                #
                        "isat_max"      : 14,                   #
                        "isat_typ"      : 16,                   #
                        "itemp_max"     : 8,                    #
                        "itemp_typ"     : 13,                   #
                        "vmax"          : 20,                   # 
                        #########################################
                        # Here below are guesses                #
                        #########################################
                        "dcr_tc"        : 3950e-6,              # Generally Cu has a Tcr of about 3950ppm/°C
                        "acrl"          : 0.6 / 2,              # AC resistance of the inductor at fsw but at no bias
                        "coreloss_k"    : 2e-9,                 # Core loss gain factor (Ω•s)
                        "coreloss_tc"   : 2025e-6,              # Core loss Tc. Increase to "spread" hot and cold core losses.
                        "thjc_ind"      : 30                    # This is made up !!!!!
                        }
TFM322512ALMAR15MTAA = {"name"          : "TFM322512ALMAR15MTAA",
                        "case_imperial" : "1210",               # Imperial case size
                        "case_metric"   : "3225",               # Metric case size
                        "l_nom"         : 150e-9,               # Nomninal inductance
                        "l_tolerance"   : 0.2,                  # Percent/100
                        "dcr_max"       : 0.009,                #
                        "dcr_typ"       : 0.005,                #
                        "isat_max"      : 12,                   #
                        "isat_typ"      : 14,                   #
                        "itemp_max"     : 8,                    #
                        "itemp_typ"     : 1,                    #
                        "vmax"          : 20,                   # 
                        #########################################
                        # Here below are guesses                #
                        #########################################
                        "dcr_tc"        : 3950e-6,              # Generally Cu has a Tcr of about 3950ppm/°C
                        "acrl"          : 0.6 / 2,              # AC resistance of the inductor at fsw but at no bias
                        "coreloss_k"    : 2e-9,                 # Core loss gain factor (Ω•s)
                        "coreloss_tc"   : 2025e-6,              # Core loss Tc. Increase to "spread" hot and cold core losses.
                        "thjc_ind"      : 30                    # This is made up !!!!!
                        }
TFM322512ALMAR22MTAA = {"name"          : "TFM322512ALMAR22MTAA",
                        "case_imperial" : "1210",               # Imperial case size
                        "case_metric"   : "3225",               # Metric case size
                        "l_nom"         : 220e-9,               # Nomninal inductance
                        "l_tolerance"   : 0.2,                  # Percent/100
                        "dcr_max"       : 0.011,                #
                        "dcr_typ"       : 0.006,                #
                        "isat_max"      : 10,                   #
                        "isat_typ"      : 12,                   #
                        "itemp_max"     : 7,                    #
                        "itemp_typ"     : 9.5,                  #
                        "vmax"          : 20,                   # 
                        #########################################
                        # Here below are guesses                #
                        #########################################
                        "dcr_tc"        : 3950e-6,              # Generally Cu has a Tcr of about 3950ppm/°C
                        "acrl"          : 0.6 / 2,              # AC resistance of the inductor at fsw but at no bias
                        "coreloss_k"    : 2e-9,                 # Core loss gain factor (Ω•s)
                        "coreloss_tc"   : 2025e-6,              # Core loss Tc. Increase to "spread" hot and cold core losses.
                        "thjc_ind"      : 30                    # This is made up !!!!!
                        }
TFM322512ALMAR33MTAA = {"name"          : "TFM322512ALMAR33MTAA",
                        "case_imperial" : "1210",               # Imperial case size
                        "case_metric"   : "3225",               # Metric case size
                        "l_nom"         : 330e-9,               # Nomninal inductance
                        "l_tolerance"   : 0.2,                  # Percent/100
                        "dcr_max"       : 0.015,                #
                        "dcr_typ"       : 0.010,                #
                        "isat_max"      : 8.6,                  #
                        "isat_typ"      : 9.5,                  #
                        "itemp_max"     : 6,                    #
                        "itemp_typ"     : 7.3,                  #
                        "vmax"          : 20,                   # 
                        #########################################
                        # Here below are guesses                #
                        #########################################
                        "dcr_tc"        : 3950e-6,              # Generally Cu has a Tcr of about 3950ppm/°C
                        "acrl"          : 0.6 / 2,              # AC resistance of the inductor at fsw but at no bias
                        "coreloss_k"    : 2e-9,                 # Core loss gain factor (Ω•s)
                        "coreloss_tc"   : 2025e-6,              # Core loss Tc. Increase to "spread" hot and cold core losses.
                        "thjc_ind"      : 30                    # This is made up !!!!!
                        }      
                        
